module data.ref.auto {
   syntax: infix '<-'.

   syntax: '<-' = '='.

   level: (goal) protected <- term.

   `<-'(A, B) :-
      A:set(B).

   syntax: prefix '?'.

   import: data.number.

   level: (term) ?protected.
   level: (term, goal) (protected++).
   level: (term, goal) (protected--).
   level: (term, goal) (++protected).
   level: (term, goal) (--protected).

   `?'(A) = A:get.

   level: (protected) p(seq(term)).

   notation: (term) A | A : var, (A:'get') / 1: predicate -> ?A.
}